// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/GraphConstraint.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/graph_constraint__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `constraint`
#include "geometry_msgs/msg/detail/pose_with_covariance__functions.h"

bool
mrpt_msgs__msg__GraphConstraint__init(mrpt_msgs__msg__GraphConstraint * msg)
{
  if (!msg) {
    return false;
  }
  // node_id_from
  // node_id_to
  // constraint
  if (!geometry_msgs__msg__PoseWithCovariance__init(&msg->constraint)) {
    mrpt_msgs__msg__GraphConstraint__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__msg__GraphConstraint__fini(mrpt_msgs__msg__GraphConstraint * msg)
{
  if (!msg) {
    return;
  }
  // node_id_from
  // node_id_to
  // constraint
  geometry_msgs__msg__PoseWithCovariance__fini(&msg->constraint);
}

mrpt_msgs__msg__GraphConstraint *
mrpt_msgs__msg__GraphConstraint__create()
{
  mrpt_msgs__msg__GraphConstraint * msg = (mrpt_msgs__msg__GraphConstraint *)malloc(sizeof(mrpt_msgs__msg__GraphConstraint));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__GraphConstraint));
  bool success = mrpt_msgs__msg__GraphConstraint__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__GraphConstraint__destroy(mrpt_msgs__msg__GraphConstraint * msg)
{
  if (msg) {
    mrpt_msgs__msg__GraphConstraint__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__GraphConstraint__Sequence__init(mrpt_msgs__msg__GraphConstraint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__GraphConstraint * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__GraphConstraint *)calloc(size, sizeof(mrpt_msgs__msg__GraphConstraint));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__GraphConstraint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__GraphConstraint__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__GraphConstraint__Sequence__fini(mrpt_msgs__msg__GraphConstraint__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__GraphConstraint__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__GraphConstraint__Sequence *
mrpt_msgs__msg__GraphConstraint__Sequence__create(size_t size)
{
  mrpt_msgs__msg__GraphConstraint__Sequence * array = (mrpt_msgs__msg__GraphConstraint__Sequence *)malloc(sizeof(mrpt_msgs__msg__GraphConstraint__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__GraphConstraint__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__GraphConstraint__Sequence__destroy(mrpt_msgs__msg__GraphConstraint__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__GraphConstraint__Sequence__fini(array);
  }
  free(array);
}
