// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/GraphSlamAgent.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/graph_slam_agent__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `name`
// Member `hostname`
// Member `ip_addr`
// Member `topic_namespace`
#include "std_msgs/msg/detail/string__functions.h"
// Member `is_online`
#include "std_msgs/msg/detail/bool__functions.h"
// Member `last_seen_time`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
mrpt_msgs__msg__GraphSlamAgent__init(mrpt_msgs__msg__GraphSlamAgent * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!std_msgs__msg__String__init(&msg->name)) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
    return false;
  }
  // hostname
  if (!std_msgs__msg__String__init(&msg->hostname)) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
    return false;
  }
  // ip_addr
  if (!std_msgs__msg__String__init(&msg->ip_addr)) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
    return false;
  }
  // port
  // is_online
  if (!std_msgs__msg__Bool__init(&msg->is_online)) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
    return false;
  }
  // last_seen_time
  if (!builtin_interfaces__msg__Time__init(&msg->last_seen_time)) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
    return false;
  }
  // topic_namespace
  if (!std_msgs__msg__String__init(&msg->topic_namespace)) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
    return false;
  }
  // agent_id
  return true;
}

void
mrpt_msgs__msg__GraphSlamAgent__fini(mrpt_msgs__msg__GraphSlamAgent * msg)
{
  if (!msg) {
    return;
  }
  // name
  std_msgs__msg__String__fini(&msg->name);
  // hostname
  std_msgs__msg__String__fini(&msg->hostname);
  // ip_addr
  std_msgs__msg__String__fini(&msg->ip_addr);
  // port
  // is_online
  std_msgs__msg__Bool__fini(&msg->is_online);
  // last_seen_time
  builtin_interfaces__msg__Time__fini(&msg->last_seen_time);
  // topic_namespace
  std_msgs__msg__String__fini(&msg->topic_namespace);
  // agent_id
}

mrpt_msgs__msg__GraphSlamAgent *
mrpt_msgs__msg__GraphSlamAgent__create()
{
  mrpt_msgs__msg__GraphSlamAgent * msg = (mrpt_msgs__msg__GraphSlamAgent *)malloc(sizeof(mrpt_msgs__msg__GraphSlamAgent));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__GraphSlamAgent));
  bool success = mrpt_msgs__msg__GraphSlamAgent__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__GraphSlamAgent__destroy(mrpt_msgs__msg__GraphSlamAgent * msg)
{
  if (msg) {
    mrpt_msgs__msg__GraphSlamAgent__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__GraphSlamAgent__Sequence__init(mrpt_msgs__msg__GraphSlamAgent__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__GraphSlamAgent * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__GraphSlamAgent *)calloc(size, sizeof(mrpt_msgs__msg__GraphSlamAgent));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__GraphSlamAgent__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__GraphSlamAgent__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__GraphSlamAgent__Sequence__fini(mrpt_msgs__msg__GraphSlamAgent__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__GraphSlamAgent__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__GraphSlamAgent__Sequence *
mrpt_msgs__msg__GraphSlamAgent__Sequence__create(size_t size)
{
  mrpt_msgs__msg__GraphSlamAgent__Sequence * array = (mrpt_msgs__msg__GraphSlamAgent__Sequence *)malloc(sizeof(mrpt_msgs__msg__GraphSlamAgent__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__GraphSlamAgent__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__GraphSlamAgent__Sequence__destroy(mrpt_msgs__msg__GraphSlamAgent__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__GraphSlamAgent__Sequence__fini(array);
  }
  free(array);
}
