// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/GraphSlamStats.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/graph_slam_stats__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `slam_evaluation_metric`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
mrpt_msgs__msg__GraphSlamStats__init(mrpt_msgs__msg__GraphSlamStats * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    mrpt_msgs__msg__GraphSlamStats__fini(msg);
    return false;
  }
  // nodes_total
  // edges_total
  // edges_icp_2d
  // edges_icp_3d
  // edges_odom
  // loop_closures
  // slam_evaluation_metric
  if (!rosidl_runtime_c__double__Sequence__init(&msg->slam_evaluation_metric, 0)) {
    mrpt_msgs__msg__GraphSlamStats__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__msg__GraphSlamStats__fini(mrpt_msgs__msg__GraphSlamStats * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // nodes_total
  // edges_total
  // edges_icp_2d
  // edges_icp_3d
  // edges_odom
  // loop_closures
  // slam_evaluation_metric
  rosidl_runtime_c__double__Sequence__fini(&msg->slam_evaluation_metric);
}

mrpt_msgs__msg__GraphSlamStats *
mrpt_msgs__msg__GraphSlamStats__create()
{
  mrpt_msgs__msg__GraphSlamStats * msg = (mrpt_msgs__msg__GraphSlamStats *)malloc(sizeof(mrpt_msgs__msg__GraphSlamStats));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__GraphSlamStats));
  bool success = mrpt_msgs__msg__GraphSlamStats__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__GraphSlamStats__destroy(mrpt_msgs__msg__GraphSlamStats * msg)
{
  if (msg) {
    mrpt_msgs__msg__GraphSlamStats__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__GraphSlamStats__Sequence__init(mrpt_msgs__msg__GraphSlamStats__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__GraphSlamStats * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__GraphSlamStats *)calloc(size, sizeof(mrpt_msgs__msg__GraphSlamStats));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__GraphSlamStats__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__GraphSlamStats__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__GraphSlamStats__Sequence__fini(mrpt_msgs__msg__GraphSlamStats__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__GraphSlamStats__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__GraphSlamStats__Sequence *
mrpt_msgs__msg__GraphSlamStats__Sequence__create(size_t size)
{
  mrpt_msgs__msg__GraphSlamStats__Sequence * array = (mrpt_msgs__msg__GraphSlamStats__Sequence *)malloc(sizeof(mrpt_msgs__msg__GraphSlamStats__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__GraphSlamStats__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__GraphSlamStats__Sequence__destroy(mrpt_msgs__msg__GraphSlamStats__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__GraphSlamStats__Sequence__fini(array);
  }
  free(array);
}
