// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/ObservationObject.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/observation_object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `sensor_pose_on_robot`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `sensed_data`
#include "mrpt_msgs/msg/detail/single_object_observation__functions.h"

bool
mrpt_msgs__msg__ObservationObject__init(mrpt_msgs__msg__ObservationObject * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    mrpt_msgs__msg__ObservationObject__fini(msg);
    return false;
  }
  // sensor_pose_on_robot
  if (!geometry_msgs__msg__Pose__init(&msg->sensor_pose_on_robot)) {
    mrpt_msgs__msg__ObservationObject__fini(msg);
    return false;
  }
  // min_sensor_distance
  // max_sensor_distance
  // sensor_std_range
  // sensor_std_yaw
  // sensor_std_pitch
  // sensed_data
  if (!mrpt_msgs__msg__SingleObjectObservation__Sequence__init(&msg->sensed_data, 0)) {
    mrpt_msgs__msg__ObservationObject__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__msg__ObservationObject__fini(mrpt_msgs__msg__ObservationObject * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // sensor_pose_on_robot
  geometry_msgs__msg__Pose__fini(&msg->sensor_pose_on_robot);
  // min_sensor_distance
  // max_sensor_distance
  // sensor_std_range
  // sensor_std_yaw
  // sensor_std_pitch
  // sensed_data
  mrpt_msgs__msg__SingleObjectObservation__Sequence__fini(&msg->sensed_data);
}

mrpt_msgs__msg__ObservationObject *
mrpt_msgs__msg__ObservationObject__create()
{
  mrpt_msgs__msg__ObservationObject * msg = (mrpt_msgs__msg__ObservationObject *)malloc(sizeof(mrpt_msgs__msg__ObservationObject));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__ObservationObject));
  bool success = mrpt_msgs__msg__ObservationObject__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__ObservationObject__destroy(mrpt_msgs__msg__ObservationObject * msg)
{
  if (msg) {
    mrpt_msgs__msg__ObservationObject__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__ObservationObject__Sequence__init(mrpt_msgs__msg__ObservationObject__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__ObservationObject * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__ObservationObject *)calloc(size, sizeof(mrpt_msgs__msg__ObservationObject));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__ObservationObject__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__ObservationObject__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__ObservationObject__Sequence__fini(mrpt_msgs__msg__ObservationObject__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__ObservationObject__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__ObservationObject__Sequence *
mrpt_msgs__msg__ObservationObject__Sequence__create(size_t size)
{
  mrpt_msgs__msg__ObservationObject__Sequence * array = (mrpt_msgs__msg__ObservationObject__Sequence *)malloc(sizeof(mrpt_msgs__msg__ObservationObject__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__ObservationObject__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__ObservationObject__Sequence__destroy(mrpt_msgs__msg__ObservationObject__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__ObservationObject__Sequence__fini(array);
  }
  free(array);
}
