// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from mrpt_msgs:msg/GenericObservation.idl
// generated code does not contain a copyright notice

#ifndef MRPT_MSGS__MSG__DETAIL__GENERIC_OBSERVATION__FUNCTIONS_H_
#define MRPT_MSGS__MSG__DETAIL__GENERIC_OBSERVATION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "mrpt_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "mrpt_msgs/msg/detail/generic_observation__struct.h"

/// Initialize msg/GenericObservation message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * mrpt_msgs__msg__GenericObservation
 * )) before or use
 * mrpt_msgs__msg__GenericObservation__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
bool
mrpt_msgs__msg__GenericObservation__init(mrpt_msgs__msg__GenericObservation * msg);

/// Finalize msg/GenericObservation message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
void
mrpt_msgs__msg__GenericObservation__fini(mrpt_msgs__msg__GenericObservation * msg);

/// Create msg/GenericObservation message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * mrpt_msgs__msg__GenericObservation__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
mrpt_msgs__msg__GenericObservation *
mrpt_msgs__msg__GenericObservation__create();

/// Destroy msg/GenericObservation message.
/**
 * It calls
 * mrpt_msgs__msg__GenericObservation__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
void
mrpt_msgs__msg__GenericObservation__destroy(mrpt_msgs__msg__GenericObservation * msg);


/// Initialize array of msg/GenericObservation messages.
/**
 * It allocates the memory for the number of elements and calls
 * mrpt_msgs__msg__GenericObservation__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
bool
mrpt_msgs__msg__GenericObservation__Sequence__init(mrpt_msgs__msg__GenericObservation__Sequence * array, size_t size);

/// Finalize array of msg/GenericObservation messages.
/**
 * It calls
 * mrpt_msgs__msg__GenericObservation__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
void
mrpt_msgs__msg__GenericObservation__Sequence__fini(mrpt_msgs__msg__GenericObservation__Sequence * array);

/// Create array of msg/GenericObservation messages.
/**
 * It allocates the memory for the array and calls
 * mrpt_msgs__msg__GenericObservation__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
mrpt_msgs__msg__GenericObservation__Sequence *
mrpt_msgs__msg__GenericObservation__Sequence__create(size_t size);

/// Destroy array of msg/GenericObservation messages.
/**
 * It calls
 * mrpt_msgs__msg__GenericObservation__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mrpt_msgs
void
mrpt_msgs__msg__GenericObservation__Sequence__destroy(mrpt_msgs__msg__GenericObservation__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // MRPT_MSGS__MSG__DETAIL__GENERIC_OBSERVATION__FUNCTIONS_H_
