// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:msg/NetworkOfPoses.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/network_of_poses__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `nodes`
#include "mrpt_msgs/msg/detail/node_id_with_pose_vec__functions.h"
// Member `constraints`
#include "mrpt_msgs/msg/detail/graph_constraint__functions.h"

bool
mrpt_msgs__msg__NetworkOfPoses__init(mrpt_msgs__msg__NetworkOfPoses * msg)
{
  if (!msg) {
    return false;
  }
  // root
  // nodes
  if (!mrpt_msgs__msg__NodeIDWithPoseVec__init(&msg->nodes)) {
    mrpt_msgs__msg__NetworkOfPoses__fini(msg);
    return false;
  }
  // constraints
  if (!mrpt_msgs__msg__GraphConstraint__Sequence__init(&msg->constraints, 0)) {
    mrpt_msgs__msg__NetworkOfPoses__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__msg__NetworkOfPoses__fini(mrpt_msgs__msg__NetworkOfPoses * msg)
{
  if (!msg) {
    return;
  }
  // root
  // nodes
  mrpt_msgs__msg__NodeIDWithPoseVec__fini(&msg->nodes);
  // constraints
  mrpt_msgs__msg__GraphConstraint__Sequence__fini(&msg->constraints);
}

mrpt_msgs__msg__NetworkOfPoses *
mrpt_msgs__msg__NetworkOfPoses__create()
{
  mrpt_msgs__msg__NetworkOfPoses * msg = (mrpt_msgs__msg__NetworkOfPoses *)malloc(sizeof(mrpt_msgs__msg__NetworkOfPoses));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__msg__NetworkOfPoses));
  bool success = mrpt_msgs__msg__NetworkOfPoses__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__msg__NetworkOfPoses__destroy(mrpt_msgs__msg__NetworkOfPoses * msg)
{
  if (msg) {
    mrpt_msgs__msg__NetworkOfPoses__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__msg__NetworkOfPoses__Sequence__init(mrpt_msgs__msg__NetworkOfPoses__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__msg__NetworkOfPoses * data = NULL;
  if (size) {
    data = (mrpt_msgs__msg__NetworkOfPoses *)calloc(size, sizeof(mrpt_msgs__msg__NetworkOfPoses));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__msg__NetworkOfPoses__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__msg__NetworkOfPoses__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__msg__NetworkOfPoses__Sequence__fini(mrpt_msgs__msg__NetworkOfPoses__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__msg__NetworkOfPoses__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__msg__NetworkOfPoses__Sequence *
mrpt_msgs__msg__NetworkOfPoses__Sequence__create(size_t size)
{
  mrpt_msgs__msg__NetworkOfPoses__Sequence * array = (mrpt_msgs__msg__NetworkOfPoses__Sequence *)malloc(sizeof(mrpt_msgs__msg__NetworkOfPoses__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__msg__NetworkOfPoses__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__msg__NetworkOfPoses__Sequence__destroy(mrpt_msgs__msg__NetworkOfPoses__Sequence * array)
{
  if (array) {
    mrpt_msgs__msg__NetworkOfPoses__Sequence__fini(array);
  }
  free(array);
}
