// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from mrpt_msgs:srv/GetCMGraph.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/srv/detail/get_cm_graph__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `node_ids`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
mrpt_msgs__srv__GetCMGraph_Request__init(mrpt_msgs__srv__GetCMGraph_Request * msg)
{
  if (!msg) {
    return false;
  }
  // node_ids
  if (!rosidl_runtime_c__uint64__Sequence__init(&msg->node_ids, 0)) {
    mrpt_msgs__srv__GetCMGraph_Request__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__srv__GetCMGraph_Request__fini(mrpt_msgs__srv__GetCMGraph_Request * msg)
{
  if (!msg) {
    return;
  }
  // node_ids
  rosidl_runtime_c__uint64__Sequence__fini(&msg->node_ids);
}

mrpt_msgs__srv__GetCMGraph_Request *
mrpt_msgs__srv__GetCMGraph_Request__create()
{
  mrpt_msgs__srv__GetCMGraph_Request * msg = (mrpt_msgs__srv__GetCMGraph_Request *)malloc(sizeof(mrpt_msgs__srv__GetCMGraph_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__srv__GetCMGraph_Request));
  bool success = mrpt_msgs__srv__GetCMGraph_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__srv__GetCMGraph_Request__destroy(mrpt_msgs__srv__GetCMGraph_Request * msg)
{
  if (msg) {
    mrpt_msgs__srv__GetCMGraph_Request__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__srv__GetCMGraph_Request__Sequence__init(mrpt_msgs__srv__GetCMGraph_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__srv__GetCMGraph_Request * data = NULL;
  if (size) {
    data = (mrpt_msgs__srv__GetCMGraph_Request *)calloc(size, sizeof(mrpt_msgs__srv__GetCMGraph_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__srv__GetCMGraph_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__srv__GetCMGraph_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__srv__GetCMGraph_Request__Sequence__fini(mrpt_msgs__srv__GetCMGraph_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__srv__GetCMGraph_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__srv__GetCMGraph_Request__Sequence *
mrpt_msgs__srv__GetCMGraph_Request__Sequence__create(size_t size)
{
  mrpt_msgs__srv__GetCMGraph_Request__Sequence * array = (mrpt_msgs__srv__GetCMGraph_Request__Sequence *)malloc(sizeof(mrpt_msgs__srv__GetCMGraph_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__srv__GetCMGraph_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__srv__GetCMGraph_Request__Sequence__destroy(mrpt_msgs__srv__GetCMGraph_Request__Sequence * array)
{
  if (array) {
    mrpt_msgs__srv__GetCMGraph_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `cm_graph`
#include "mrpt_msgs/msg/detail/network_of_poses__functions.h"

bool
mrpt_msgs__srv__GetCMGraph_Response__init(mrpt_msgs__srv__GetCMGraph_Response * msg)
{
  if (!msg) {
    return false;
  }
  // cm_graph
  if (!mrpt_msgs__msg__NetworkOfPoses__init(&msg->cm_graph)) {
    mrpt_msgs__srv__GetCMGraph_Response__fini(msg);
    return false;
  }
  return true;
}

void
mrpt_msgs__srv__GetCMGraph_Response__fini(mrpt_msgs__srv__GetCMGraph_Response * msg)
{
  if (!msg) {
    return;
  }
  // cm_graph
  mrpt_msgs__msg__NetworkOfPoses__fini(&msg->cm_graph);
}

mrpt_msgs__srv__GetCMGraph_Response *
mrpt_msgs__srv__GetCMGraph_Response__create()
{
  mrpt_msgs__srv__GetCMGraph_Response * msg = (mrpt_msgs__srv__GetCMGraph_Response *)malloc(sizeof(mrpt_msgs__srv__GetCMGraph_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(mrpt_msgs__srv__GetCMGraph_Response));
  bool success = mrpt_msgs__srv__GetCMGraph_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
mrpt_msgs__srv__GetCMGraph_Response__destroy(mrpt_msgs__srv__GetCMGraph_Response * msg)
{
  if (msg) {
    mrpt_msgs__srv__GetCMGraph_Response__fini(msg);
  }
  free(msg);
}


bool
mrpt_msgs__srv__GetCMGraph_Response__Sequence__init(mrpt_msgs__srv__GetCMGraph_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  mrpt_msgs__srv__GetCMGraph_Response * data = NULL;
  if (size) {
    data = (mrpt_msgs__srv__GetCMGraph_Response *)calloc(size, sizeof(mrpt_msgs__srv__GetCMGraph_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = mrpt_msgs__srv__GetCMGraph_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        mrpt_msgs__srv__GetCMGraph_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
mrpt_msgs__srv__GetCMGraph_Response__Sequence__fini(mrpt_msgs__srv__GetCMGraph_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      mrpt_msgs__srv__GetCMGraph_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

mrpt_msgs__srv__GetCMGraph_Response__Sequence *
mrpt_msgs__srv__GetCMGraph_Response__Sequence__create(size_t size)
{
  mrpt_msgs__srv__GetCMGraph_Response__Sequence * array = (mrpt_msgs__srv__GetCMGraph_Response__Sequence *)malloc(sizeof(mrpt_msgs__srv__GetCMGraph_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = mrpt_msgs__srv__GetCMGraph_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
mrpt_msgs__srv__GetCMGraph_Response__Sequence__destroy(mrpt_msgs__srv__GetCMGraph_Response__Sequence * array)
{
  if (array) {
    mrpt_msgs__srv__GetCMGraph_Response__Sequence__fini(array);
  }
  free(array);
}
